; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 440
WINDOWHEIGHT = 400
yrot	equ xrot+4
zrot	equ xrot+8
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	FSize:dword
local	texName:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	mov	ecx,texture
	invoke	GlobalFree
	invoke	RtlExitUserProcess,NULL
wmTIMER:movaps	xmm0,xrot
	addps	xmm0,delta;0.14, 0.14, 0.14
	movaps	xrot,xmm0
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;-------------------------------------------------------
	mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,\
	FILE_ATTRIBUTE_ARCHIVE,rbx
        mov	esi,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,eax
        mov	edi,eax
	mov	[rsp+20h],rbx
	lea	r9d,szReadWrite
        invoke	ReadFile,esi,eax,FSize
        invoke	CloseHandle,esi
	mov	esi,edi
        add	esi,[rdi + BITMAPFILEHEADER.bfOffBits]
	lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	w,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	h,eax
	lea	edx,texName
	invoke	glGenTextures,1
	invoke	glBindTexture,GL_TEXTURE_2D,1
        mov	r9d,w
        mov	eax,h
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3,,rax,rbx,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
;--------------------------------------------------------------
        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;    ,   
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
	invoke	glEnable,GL_DEPTH_TEST ;  
	invoke	glDepthFunc,GL_LEQUAL ;  
;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST;
;     
	invoke	glMatrixMode,GL_PROJECTION;     ()
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke	glLoadIdentity
;     (z=-6)
	movd	xmm2,const_6
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef

	movd	xmm6,const1
	xorps	xmm7,xmm7
	subss	xmm7,xmm6

	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,xmm6
	movd	xmm0,xrot
	invoke	glRotatef
	xorps	xmm3,xmm3
	movss	xmm2,xmm6
	xorps	xmm1,xmm1
	movd	xmm0,yrot
	invoke	glRotatef
	movss	xmm3,xmm6
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movd	xmm0,zrot
	invoke	glRotatef

        invoke	glBindTexture,GL_TEXTURE_2D,1

	invoke	glBegin,GL_QUADS
;front
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
        invoke	glTexCoord2f;0,0
	movss	xmm2,xmm6
	movss	xmm1,xmm7
	movss	xmm0,xmm1
	invoke	glVertex3f;-1,-1,1
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
        invoke	glTexCoord2f;1,0
	movss	xmm2,xmm6
	movss	xmm1,xmm7
	movss	xmm0,xmm2
	invoke	glVertex3f;1,-1,1
	movss	xmm1,xmm6
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1
	movss	xmm2,xmm6
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;1, 1, 1
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
	invoke	glTexCoord2f; 0,1
	movss	xmm2,xmm6
	movss	xmm1,xmm2
	movss	xmm0,xmm7
	invoke	glVertex3f;-1, 1, 1
;back
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
	invoke	glTexCoord2f; 1,0
	movss	xmm2,xmm7
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;-1,-1,-1
	movss	xmm1,xmm6
	movss	xmm0,xmm1
	invoke	glTexCoord2f; 1,1
	movss	xmm2,xmm7
	movss	xmm1,xmm6
	movss	xmm0,xmm2
	invoke	glVertex3f;(-1,1,-1
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1
	movss	xmm2,xmm7
	movss	xmm1,xmm6
	movss	xmm0,xmm1
	invoke	glVertex3f;(1,1,-1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,0
	movss	xmm2,xmm7
	movss	xmm1,xmm2
	movss	xmm0,xmm6
	invoke	glVertex3f;( 1,-1,-1
;top
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
	invoke	glTexCoord2f ;0,1
	movss	xmm2,xmm7
	movss	xmm1,xmm6
	movss	xmm0,xmm2
	invoke	glVertex3f;(-1, 1,-1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f
	movss	xmm2,xmm6
	movss	xmm1,xmm2
	movss	xmm0,xmm7
	invoke	glVertex3f;(-1, 1, 1
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
	invoke	glTexCoord2f
	movss	xmm2,xmm6
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;(1,1, 1
	movss	xmm1,xmm6
	movss	xmm0,xmm1
	invoke	glTexCoord2f
	movss	xmm2,xmm7
	movss	xmm1,xmm6
	movss	xmm0,xmm1
	invoke	glVertex3f;( 1,-1, 1
;bottom
	movss	xmm1,xmm6
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1
	movss	xmm2,xmm7
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;( -1,-1,-1
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,0
	movss	xmm2,xmm7
	movss	xmm1,xmm2
	movss	xmm0,xmm6
	invoke	glVertex3f;(-1,1,1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;
	movss	xmm2,xmm6
	movss	xmm1,xmm7
	movss	xmm0,xmm2
	invoke	glVertex3f;(1, -1,1
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
	invoke	glTexCoord2f
	movss	xmm2,xmm6
	movss	xmm1,xmm7
	movss	xmm0,xmm1
	invoke	glVertex3f;( -1, -1,1
;right
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
	invoke	glTexCoord2f
	movss	xmm2,xmm7
	movss	xmm1,xmm2
	movss	xmm0,xmm6
	invoke	glVertex3f;1, -1, -1
	movss	xmm1,xmm6
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1
	movss	xmm2,xmm7
	movss	xmm1,xmm6
	movss	xmm0,xmm1
	invoke	glVertex3f;(1, 1,-1
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;
	movss	xmm2,xmm6
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;1,1,1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f
	movss	xmm2,xmm6
	movss	xmm1,xmm7
	movss	xmm0,xmm2
	invoke	glVertex3f;(1,-1, 1
;left	
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,0
	movss	xmm2,xmm7
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f; -1, -1,-1
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
	invoke	glTexCoord2f;1,0
	movss	xmm2,xmm6
	movss	xmm1,xmm7
	movss	xmm0,xmm1
	invoke	glVertex3f; -1, -1, 1
	movss	xmm1,xmm6
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1
	movss	xmm2,xmm6
	movss	xmm1,xmm2
	movss	xmm0,xmm7
	invoke	glVertex3f; -1,1, 1
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,1
	movss	xmm2,xmm7
	movss	xmm1,xmm6
	movss	xmm0,xmm2
	invoke	glVertex3f;-1,1,-1

	invoke	glEnd
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #6: Texture Mapping",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "NeHe.bmp",0
texture		dd ?
;-----------------------------
;float
const1		dd 1.0
const_6		dd -6.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
align 16
xrot		dd 0,  0,  0,  0
delta		dd 1.4,1.4,1.4,0
end